#ifndef __PWM_H__
#define __PWM_H__

/*
  DEV By IOXhop : www.ioxhop.com
  Sonthaya Nongnuch : fb.me/maxthai
*/

#include "driver.h"
#include "device.h"
#include "driver/uart.h"
#include "driver/ledc.h"
#include "kidbright32.h"

class pwm : public Device {
	private:		
		struct configState {
			uint8_t pin;
			uint8_t ledc_ch;
		} pwmConfigState[5];
		uint8_t nextPointPWMConfigState = 0;
		
		uint8_t getIndexFromPin(uint8_t pin) ;
		uint8_t getLEDCChannelFromPin(uint8_t pin) ;
		uint8_t setupLEDCFromPin(uint8_t pin) ;

	public:
		// constructor
		pwm() ;
		
		// override
		void init(void);
		void process(Driver *drv);
		int prop_count(void);
		bool prop_name(int index, char *name);
		bool prop_unit(int index, char *unit);
		bool prop_attr(int index, char *attr);
		bool prop_read(int index, char *value);
		bool prop_write(int index, char *value);
		
		// method
		void setDuty(uint8_t pin, double duty) ;
		
};

#endif
